
clear
close all
flag=1;  % CSOPIM 
load rsiso   % The external excitation data consisting of r and t.   
% r=randn(1200,1); %You may also generate new excitation by using line 6 & 7
% t=[0:1199]';
%---------------------- initial seed for random number generators
seed0=0;
seed3=3533;
seed5=5788;
%------------------state space model parameters for simulink model
AA=[4.4 1 0 0 0;-8.09 0 1 0 0;7.83 0 0 1 0;-4 0 0 0 1;0.86 0 0 0 0];    %Plant
BB=[0.00098 0.01299 0.01859 0.0033 -0.00002]';
CC=[1 0 0 0 0];
DD=0;

Ad=[4.4 1 0 0 0;-8.09 0 1 0 0;7.83 0 0 1 0;-4 0 0 0 1;0.86 0 0 0 0];    %disturbance
Bd=[2.3 -6.64 7.515 -4.0146 0.86336]';
Cd=[1 0 0 0 0];
Dd=1;

Ac=[2.65 -3.11 1.75 -0.39;1 0 0 0;0 1 0 0;0 0 1 0];  %control
Bc=[1 0 0 0]';
Cc=[-0.4135 0.8629 -0.7625 0.2521];
Dc=0.61

sys0=ss(AA,BB,CC,DD,1);
[M0 P0 W]=bode(sys0);

Pr=[];
Pi=[];

for kk=1:100
kk
vm=0.2;
%vm=0.5;  % increased measurement noise
sim('model_siso_eiv',1199);
%-------------------- Continuously varying seeds for Monte-carlo simulations
seed0=seed0+1;
seed3=seed3+1;
seed5=seed5+1;
i=10;
p=1;
q=1;
o=5;

[A B C D]=subspaceID(r,u,y,o,i,flag);  % CSOPIM subspace identification
syshat=ss(A,B,C,D,1);  % estimated model

[M]=bode(syshat,W);
M11(:,kk)=squeeze(M(1,1,:));

Pr(kk,:)=real(eig(A))';
Pi(kk,:)=imag(eig(A))';
end

M011=squeeze(M0(1,1,:));
M011=20*log10(M011);

Mm11=mean(M11,2);
Mm11=20*log10(Mm11);

figure(1)
subplot(421)
semilogx(W,M011,'r:',W,Mm11,'-');
title('Magnitude Plot')
ylabel('dB')
xlabel('rad/sec')

subplot(422)
plot(Pr,Pi,'x')
xlabel('Real Part')
ylabel('Imag Part')
hold on
plot(real(eig(AA)), imag(eig(AA)),'black+')
axis([0.1 1.5 -0.7 0.7])
hold off